
#property copyright "fx-auto-trader@mail.ru  2008"
#property link      ""

extern double StartLots = 0.1;
extern int Step = 57;
extern double LossLimitLevel = 25.0;
extern int ReInvest = 10000;
double gd_100 = 0.0;
int gi_108 = 1;
int gi_112 = 2;
int gi_116 = 14;
int gi_120 = 3;
bool gi_124 = FALSE;
bool gi_128 = FALSE;
bool gi_132 = TRUE;
bool gi_136 = TRUE;
bool gi_140 = FALSE;
double gd_unused_144 = 0.0;

void deleteAll() {
   int l_ord_total_8 = OrdersTotal();
   for (int l_pos_12 = 0; l_pos_12 < l_ord_total_8; l_pos_12++) {
      OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderType() == OP_BUY) {
            OrderClose(OrderTicket(), OrderLots(), Bid, 2, CLR_NONE);
            Sleep(500);
         }
         if (OrderType() == OP_SELL) {
            OrderClose(OrderTicket(), OrderLots(), Ask, 2, CLR_NONE);
            Sleep(500);
         }
         if (OrderType() == OP_BUYLIMIT || OrderType() == OP_SELLLIMIT || OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) {
            OrderDelete(OrderTicket());
            Sleep(500);
         }
      }
   }
}

void setNewTakeProfitBuy(double a_price_0) {
   bool l_bool_16;
   int l_error_20;
   int l_ord_total_8 = OrdersTotal();
   for (int l_pos_12 = 0; l_pos_12 < l_ord_total_8; l_pos_12++) {
      OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderType() == OP_BUY && OrderMagicNumber() >= 101 && OrderMagicNumber() <= 112) {
         if (NormalizeDouble(OrderTakeProfit(), Digits) != NormalizeDouble(a_price_0, Digits)) {
            l_bool_16 = OrderModify(OrderTicket(), OrderOpenPrice(), 0, a_price_0, 0, Green);
            if (gi_140 == TRUE) Print(" TP  OP_BUY. TP_New = ", OrderTakeProfit(), " -> ", a_price_0, " lots = ", OrderLots(), " num = ", OrderTicket());
            if (gi_140 == TRUE) Print(" = ", l_bool_16);
            if (l_bool_16 != TRUE) {
               l_error_20 = GetLastError();
               if (gi_140 == TRUE) Print(" = ", l_error_20);
            }
            Sleep(1000 * gi_120);
         }
      }
   }
}

void setNewTakeProfitSel(double a_price_0) {
   bool l_bool_16;
   int l_error_20;
   int l_ord_total_8 = OrdersTotal();
   for (int l_pos_12 = 0; l_pos_12 < l_ord_total_8; l_pos_12++) {
      OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderType() == OP_SELL && OrderMagicNumber() >= 201 && OrderMagicNumber() <= 212) {
         if (NormalizeDouble(OrderTakeProfit(), Digits) != NormalizeDouble(a_price_0, Digits)) {
            l_bool_16 = OrderModify(OrderTicket(), OrderOpenPrice(), 0, a_price_0, 0, Yellow);
            if (gi_140 == TRUE) Print(" TP  OP_SELL. TP_New = ", OrderTakeProfit(), " -> ", a_price_0, " lots = ", OrderLots(), " num = ", OrderTicket());
            if (gi_140 == TRUE) Print(" = ", l_bool_16);
            if (l_bool_16 != TRUE) {
               l_error_20 = GetLastError();
               if (gi_140 == TRUE) Print(" = ", l_error_20);
            }
            Sleep(1000 * gi_120);
         }
      }
   }
}

double getNextOrderPriceByNum(int ai_0, double ad_4) {
   if (gi_124 == FALSE && gi_128 == FALSE) {
      switch (ai_0) {
      case 101:
         return (ad_4 - Step * Point);
      case 102:
         return (ad_4 - Step * MathPow(1, 1) * Point);
      case 103:
         return (ad_4 - Step * MathPow(1, 2) * Point);
      case 104:
         return (ad_4 - Step * MathPow(1, 3) * Point);
      case 105:
         return (ad_4 - Step * MathPow(1, 4) * Point);
      case 106:
         return (ad_4 - Step * MathPow(1, 5) * Point);
      case 107:
         return (ad_4 - Step * MathPow(1, 6) * Point);
      case 108:
         return (ad_4 - Step * MathPow(1, 7) * Point);
      case 109:
         return (ad_4 - Step * MathPow(1, 8) * Point);
      case 110:
         return (ad_4 - Step * MathPow(1, 9) * Point);
      case 111:
         return (ad_4 - Step * MathPow(1, 10) * Point);
      case 201:
         return (ad_4 + Step * Point);
      case 202:
         return (ad_4 + Step * MathPow(1, 1) * Point);
      case 203:
         return (ad_4 + Step * MathPow(1, 2) * Point);
      case 204:
         return (ad_4 + Step * MathPow(1, 3) * Point);
      case 205:
         return (ad_4 + Step * MathPow(1, 4) * Point);
      case 206:
         return (ad_4 + Step * MathPow(1, 5) * Point);
      case 207:
         return (ad_4 + Step * MathPow(1, 6) * Point);
      case 208:
         return (ad_4 + Step * MathPow(1, 7) * Point);
      case 209:
         return (ad_4 + Step * MathPow(1, 8) * Point);
      case 210:
         return (ad_4 + Step * MathPow(1, 9) * Point);
      case 211:
         return (ad_4 + Step * MathPow(1, 10) * Point);
      }
      return (0);
   }
   if (gi_124 == FALSE && gi_128 == TRUE) {
      switch (ai_0) {
      case 101:
         return (ad_4 - Step * Point);
      case 102:
         return (ad_4 - Step * MathPow(gi_112, 1) * Point);
      case 103:
         return (ad_4 - Step * MathPow(gi_112, 2) * Point);
      case 104:
         return (ad_4 - Step * MathPow(gi_112, 3) * Point);
      case 105:
         return (ad_4 - Step * MathPow(gi_112, 4) * Point);
      case 106:
         return (ad_4 - Step * MathPow(gi_112, 5) * Point);
      case 107:
         return (ad_4 - Step * MathPow(gi_112, 6) * Point);
      case 108:
         return (ad_4 - Step * MathPow(gi_112, 7) * Point);
      case 109:
         return (ad_4 - Step * MathPow(gi_112, 8) * Point);
      case 110:
         return (ad_4 - Step * MathPow(gi_112, 9) * Point);
      case 111:
         return (ad_4 - Step * MathPow(gi_112, 10) * Point);
      case 201:
         return (ad_4 + Step * Point);
      case 202:
         return (ad_4 + Step * MathPow(gi_112, 1) * Point);
      case 203:
         return (ad_4 + Step * MathPow(gi_112, 2) * Point);
      case 204:
         return (ad_4 + Step * MathPow(gi_112, 3) * Point);
      case 205:
         return (ad_4 + Step * MathPow(gi_112, 4) * Point);
      case 206:
         return (ad_4 + Step * MathPow(gi_112, 5) * Point);
      case 207:
         return (ad_4 + Step * MathPow(gi_112, 6) * Point);
      case 208:
         return (ad_4 + Step * MathPow(gi_112, 7) * Point);
      case 209:
         return (ad_4 + Step * MathPow(gi_112, 8) * Point);
      case 210:
         return (ad_4 + Step * MathPow(gi_112, 9) * Point);
      case 211:
         return (ad_4 + Step * MathPow(gi_112, 10) * Point);
      }
      return (0);
   }
   if (gi_124 == TRUE && gi_128 == FALSE) {
      switch (ai_0) {
      case 101:
         return (ad_4 - Step * Point);
      case 102:
         return (ad_4 - Step * MathPow(gi_112 + 1, 1) * Point);
      case 103:
         return (ad_4 - Step * MathPow(gi_112 + 1, 1) * Point + Step * Point);
      case 104:
         return (ad_4 - Step * MathPow(gi_112 + 1, 2) * Point);
      case 105:
         return (ad_4 - Step * MathPow(gi_112 + 1, 2) * Point + Step * Point);
      case 106:
         return (ad_4 - Step * MathPow(gi_112 + 1, 3) * Point);
      case 107:
         return (ad_4 - Step * MathPow(gi_112 + 1, 3) * Point + Step * Point);
      case 108:
         return (ad_4 - Step * MathPow(gi_112 + 1, 4) * Point);
      case 109:
         return (ad_4 - Step * MathPow(gi_112 + 1, 4) * Point + Step * Point);
      case 110:
         return (ad_4 - Step * MathPow(gi_112 + 1, 5) * Point);
      case 111:
         return (ad_4 - Step * MathPow(gi_112 + 1, 5) * Point + Step * Point);
      case 201:
         return (ad_4 + Step * Point);
      case 202:
         return (ad_4 + Step * MathPow(gi_112 + 1, 1) * Point);
      case 203:
         return (ad_4 + Step * MathPow(gi_112 + 1, 1) * Point + Step * Point);
      case 204:
         return (ad_4 + Step * MathPow(gi_112 + 1, 2) * Point);
      case 205:
         return (ad_4 + Step * MathPow(gi_112 + 1, 2) * Point + Step * Point);
      case 206:
         return (ad_4 + Step * MathPow(gi_112 + 1, 3) * Point);
      case 207:
         return (ad_4 + Step * MathPow(gi_112 + 1, 3) * Point + Step * Point);
      case 208:
         return (ad_4 + Step * MathPow(gi_112 + 1, 4) * Point);
      case 209:
         return (ad_4 + Step * MathPow(gi_112 + 1, 4) * Point + Step * Point);
      case 210:
         return (ad_4 + Step * MathPow(gi_112 + 1, 5) * Point);
      case 211:
         return (ad_4 + Step * MathPow(gi_112 + 1, 5) * Point + Step * Point);
      }
      return (0);
   }
   return (0.0);
}

int modOrder(int a_magic_0, double ad_4, double ad_12) {
   bool l_bool_28;
   int l_error_32;
   double l_price_36;
   double l_price_44;
   int l_ord_total_20 = OrdersTotal();
   for (int l_pos_24 = 0; l_pos_24 < l_ord_total_20; l_pos_24++) {
      OrderSelect(l_pos_24, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == a_magic_0) {
         if (OrderOpenPrice() != ad_4 || OrderTakeProfit() != ad_12 && ad_4 != 0.0 && ad_12 != 0.0) {
            if (OrderType() == OP_BUYLIMIT) {
               l_price_36 = ad_4;
               l_price_44 = ad_12;
               if (NormalizeDouble(OrderOpenPrice(), Digits) != NormalizeDouble(l_price_36, Digits) || NormalizeDouble(OrderTakeProfit(), Digits) != NormalizeDouble(l_price_44, Digits)) {
                  l_bool_28 = OrderModify(OrderTicket(), l_price_36, 0, l_price_44, 0, Red);
                  if (gi_140 == TRUE) Print(" BUYLIMIT ", OrderOpenPrice(), " -> ", l_price_36, " T/P ", OrderTakeProfit(), " -> ", l_price_44);
                  if (gi_140 == TRUE) Print(" = ", l_bool_28);
                  if (l_bool_28 != TRUE) {
                     l_error_32 = GetLastError();
                     if (gi_140 == TRUE) Print(" = ", l_error_32);
                  }
                  Sleep(1000 * gi_120);
               }
            }
            if (OrderType() == OP_SELLLIMIT) {
               l_price_36 = ad_4;
               l_price_44 = ad_12;
               if (NormalizeDouble(OrderOpenPrice(), Digits) != NormalizeDouble(l_price_36, Digits) || NormalizeDouble(OrderTakeProfit(), Digits) != NormalizeDouble(l_price_44, Digits)) {
                  l_bool_28 = OrderModify(OrderTicket(), l_price_36, 0, l_price_44, 0, Green);
                  if (gi_140 == TRUE) Print(" SELLLIMIT ", OrderOpenPrice(), " -> ", l_price_36, " T/P ", OrderTakeProfit(), " -> ", l_price_44);
                  if (gi_140 == TRUE) Print(" = ", l_bool_28);
                  if (l_bool_28 != TRUE) {
                     l_error_32 = GetLastError();
                     if (gi_140 == TRUE) Print(" = ", l_error_32);
                  }
                  Sleep(1000 * gi_120);
               }
            }
         }
      }
   }
   return (1);
}

int isMagNum(int ai_0, int a_magic_4) {
   int l_ord_total_8 = OrdersTotal();
   for (int l_pos_12 = 0; l_pos_12 < l_ord_total_8; l_pos_12++) {
      OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES);
      if (ai_0 == 1)
         if (OrderMagicNumber() == a_magic_4 && OrderSymbol() == Symbol()) return (1);
      if (ai_0 == 2)
         if (OrderMagicNumber() == a_magic_4 && OrderSymbol() == Symbol() && OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) return (1);
   }
   return (0);
}

int isOrderActive(int a_magic_0) {
   int l_ord_total_4 = OrdersTotal();
   for (int l_pos_8 = 0; l_pos_8 < l_ord_total_4; l_pos_8++) {
      OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == a_magic_0 && OrderType() == OP_BUY || OrderType() == OP_SELL) return (1);
   }
   return (0);
}

int getMaxLongNum() {
   int l_magic_0 = 0;
   int l_ord_total_4 = OrdersTotal();
   for (int l_pos_8 = 0; l_pos_8 < l_ord_total_4; l_pos_8++) {
      OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderType() == OP_BUY && OrderMagicNumber() > l_magic_0) l_magic_0 = OrderMagicNumber();
   }
   return (l_magic_0);
}

int getMaxShortNum() {
   int l_magic_0 = 0;
   int l_ord_total_4 = OrdersTotal();
   for (int l_pos_8 = 0; l_pos_8 < l_ord_total_4; l_pos_8++) {
      OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderType() == OP_SELL && OrderMagicNumber() > l_magic_0) l_magic_0 = OrderMagicNumber();
   }
   return (l_magic_0);
}

int getTopLevel(int ai_0) {
   int li_ret_12;
   int li_16 = 0;
   int l_ord_total_4 = OrdersTotal();
   if (ai_0 == 1) {
      for (int l_pos_8 = 0; l_pos_8 < l_ord_total_4; l_pos_8++) {
         OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol() && OrderType() == OP_BUY) {
            switch (OrderMagicNumber()) {
            case 112:
               li_16 = 12;
               break;
            case 111:
               li_16 = 11;
               break;
            case 110:
               li_16 = 10;
               break;
            case 109:
               li_16 = 9;
               break;
            case 108:
               li_16 = 8;
               break;
            case 107:
               li_16 = 7;
               break;
            case 106:
               li_16 = 6;
               break;
            case 105:
               li_16 = 5;
               break;
            case 104:
               li_16 = 4;
               break;
            case 103:
               li_16 = 3;
               break;
            case 102:
               li_16 = 2;
               break;
            case 101:
               li_16 = 1;
            }
            if (li_16 > li_ret_12) li_ret_12 = li_16;
         }
      }
      return (li_ret_12);
   }
   if (ai_0 == 2) {
      for (l_pos_8 = 0; l_pos_8 < l_ord_total_4; l_pos_8++) {
         OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol() && OrderType() == OP_SELL) {
            switch (OrderMagicNumber()) {
            case 212:
               li_16 = 12;
               break;
            case 211:
               li_16 = 11;
               break;
            case 210:
               li_16 = 10;
               break;
            case 209:
               li_16 = 9;
               break;
            case 208:
               li_16 = 8;
               break;
            case 207:
               li_16 = 7;
               break;
            case 206:
               li_16 = 6;
               break;
            case 205:
               li_16 = 5;
               break;
            case 204:
               li_16 = 4;
               break;
            case 203:
               li_16 = 3;
               break;
            case 202:
               li_16 = 2;
               break;
            case 201:
               li_16 = 1;
            }
            if (li_16 > li_ret_12) li_ret_12 = li_16;
         }
      }
      return (li_ret_12);
   }
   return (0);
}

double getOrderPriceByNum(int a_magic_0) {
   int l_ord_total_4 = OrdersTotal();
   for (int l_pos_8 = 0; l_pos_8 < l_ord_total_4; l_pos_8++) {
      OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == a_magic_0) return (OrderOpenPrice());
   }
   return (0);
}

int getNextOrderNum(int ai_0) {
   switch (ai_0) {
   case 101:
      return (102);
   case 102:
      return (103);
   case 103:
      return (104);
   case 104:
      return (105);
   case 105:
      return (106);
   case 106:
      return (107);
   case 107:
      return (108);
   case 108:
      return (109);
   case 109:
      return (110);
   case 110:
      return (111);
   case 111:
      return (112);
   case 201:
      return (202);
   case 202:
      return (203);
   case 203:
      return (204);
   case 204:
      return (205);
   case 205:
      return (206);
   case 206:
      return (207);
   case 207:
      return (208);
   case 208:
      return (209);
   case 209:
      return (210);
   case 210:
      return (211);
   case 211:
      return (212);
   }
   return (0);
}

double getLotByLevel(int ai_0) {
   double ld_ret_4 = 0;
   double ld_12 = 0;
   double ld_20 = 0;
   double ld_28 = 0;
   if (ReInvest > 0 && StartLots == 0.0) {
      ld_20 = MathFloor(AccountBalance() / (ReInvest * gi_108));
      ld_12 = ld_20 / 10.0;
      if (ld_20 > 1.0) ld_28 = ld_12;
      else ld_28 = 0.1;
      ld_ret_4 = ld_28;
   }
   if (ReInvest == 0 && StartLots > 0.0) ld_ret_4 = StartLots;
   if (ReInvest == 0 && StartLots > 0.0) ld_28 = StartLots;
   if (gi_116 == 14) {
      switch (ai_0) {
      case 2:
         ld_ret_4 = 2.0 * ld_28;
         break;
      case 3:
         ld_ret_4 = 4.0 * ld_28;
         break;
      case 4:
         ld_ret_4 = 8.0 * ld_28;
         break;
      case 5:
         ld_ret_4 = 16.0 * ld_28;
         break;
      case 6:
         ld_ret_4 = 32.0 * ld_28;
         break;
      case 7:
         ld_ret_4 = 64.0 * ld_28;
         break;
      case 8:
         ld_ret_4 = 128.0 * ld_28;
         break;
      case 9:
         ld_ret_4 = 256.0 * ld_28;
         break;
      case 10:
         ld_ret_4 = 512.0 * ld_28;
         break;
      case 11:
         ld_ret_4 = 1024.0 * ld_28;
         break;
      case 12:
         ld_ret_4 = 2048.0 * ld_28;
      }
      return (ld_ret_4);
   }
   if (gi_116 == 0) ld_ret_4 = ld_28;
   return (ld_ret_4);
}

void Create_Prima_Buy() {
   int l_ticket_0;
   int l_error_4;
   if (gi_132) {
      l_ticket_0 = OrderSend(Symbol(), OP_BUY, getLotByLevel(1), Ask, 3, 0, Ask + Step * Point, "101   ", 101, 0, Red);
      if (gi_140 == TRUE) Print("     101  -> ", Symbol(), " Ask = ", Ask, " T/P = ", Ask + Step * Point, " iet = ", l_ticket_0);
      if (l_ticket_0 == -1) {
         l_error_4 = GetLastError();
         if (gi_140 == TRUE) Print("      101 = ", l_error_4);
      }
      Sleep(1000 * gi_120);
   }
}

void Create_Prima_Sell() {
   int l_ticket_0;
   int l_error_4;
   if (gi_136) {
      l_ticket_0 = OrderSend(Symbol(), OP_SELL, getLotByLevel(1), Bid, 3, 0, Bid - Step * Point, "201   ", 201, 0, Green);
      if (gi_140 == TRUE) Print("     201  -> ", Symbol(), " Bid = ", Bid, " / = ", Bid - Step * Point, " iket = ", l_ticket_0);
      if (l_ticket_0 == -1) {
         l_error_4 = GetLastError();
         if (gi_140 == TRUE) Print("      201 = ", l_error_4);
      }
      Sleep(1000 * gi_120);
   }
}

void Create_Modify_Prima_BuyStop() {
   int li_8;
   int l_error_12;
   double ld_20;
   double l_price_28;
   int li_16 = getMaxLongNum();
   if (li_16 == 101) {
      ld_20 = getOrderPriceByNum(li_16);
      l_price_28 = ld_20 + Step * Point + Point * MarketInfo(Symbol(), MODE_SPREAD);
   }
   if (li_16 > 101) {
      ld_20 = getOrderPriceByNum(li_16 - 1);
      l_price_28 = ld_20 + Point * MarketInfo(Symbol(), MODE_SPREAD);
   }
   if (isMagNum(2, 101) == 0 && gi_132 == TRUE) {
      li_8 = OrderSend(Symbol(), OP_BUYSTOP, getLotByLevel(1), l_price_28, 3, 0, l_price_28 + Step * Point, "BUY_STOP_101", 101, 0, Red);
      if (gi_140 == TRUE) Print(" BUY_STOP_101  -> ", Symbol(), " Ask = ", l_price_28, " T/P = ", l_price_28 + Step * Point, " iet = ", li_8);
      if (li_8 == -1) {
         l_error_12 = GetLastError();
         if (gi_140 == TRUE) Print("  BUY_STOP_101 = ", l_error_12);
      }
      Sleep(1000 * gi_120);
      return;
   }
   int l_ord_total_0 = OrdersTotal();
   for (int l_pos_4 = 0; l_pos_4 < l_ord_total_0; l_pos_4++) {
      OrderSelect(l_pos_4, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == 101 && OrderSymbol() == Symbol() && OrderType() == OP_BUYSTOP) {
         if (NormalizeDouble(OrderOpenPrice(), Digits) != NormalizeDouble(l_price_28, Digits) || NormalizeDouble(OrderTakeProfit(), Digits) != NormalizeDouble(l_price_28 +
            Step * Point, Digits)) {
            li_8 = OrderModify(OrderTicket(), l_price_28, 0, l_price_28 + Step * Point, 0, Red);
            if (gi_140 == TRUE) Print(" BUY_STOP_101 ", OrderOpenPrice(), " -> ", l_price_28, " T/P = ", OrderTakeProfit(), " -> ", l_price_28 + Step * Point);
            if (li_8 == 0) {
               l_error_12 = GetLastError();
               if (gi_140 == TRUE) Print("  BUY_STOP_101 = ", l_error_12);
            }
            Sleep(1000 * gi_120);
            return;
         }
      }
   }
}

void Create_Modify_Prima_SellStop() {
   int li_8;
   int l_error_12;
   double ld_20;
   double l_price_28;
   int li_16 = getMaxShortNum();
   if (li_16 == 201) {
      ld_20 = getOrderPriceByNum(li_16);
      l_price_28 = ld_20 - Step * Point - Point * MarketInfo(Symbol(), MODE_SPREAD);
   }
   if (li_16 > 201) {
      ld_20 = getOrderPriceByNum(li_16 - 1);
      l_price_28 = ld_20 - Point * MarketInfo(Symbol(), MODE_SPREAD);
   }
   if (isMagNum(2, 201) == 0 && gi_136 == TRUE) {
      li_8 = OrderSend(Symbol(), OP_SELLSTOP, getLotByLevel(1), l_price_28, 3, 0, l_price_28 - Step * Point, "SELL_STOP_201", 201, 0, Green);
      if (gi_140 == TRUE) Print(" SELL_STOP_201  -> ", Symbol(), " Bid = ", l_price_28, " / = ", l_price_28 - Step * Point, " iket = ", li_8);
      if (li_8 == -1) {
         l_error_12 = GetLastError();
         if (gi_140 == TRUE) Print("  SELL_STOP_201 = ", l_error_12);
      }
      Sleep(1000 * gi_120);
      return;
   }
   int l_ord_total_0 = OrdersTotal();
   for (int l_pos_4 = 0; l_pos_4 < l_ord_total_0; l_pos_4++) {
      OrderSelect(l_pos_4, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber() == 201 && OrderSymbol() == Symbol() && OrderType() == OP_SELLSTOP) {
         if (NormalizeDouble(OrderOpenPrice(), Digits) != NormalizeDouble(l_price_28, Digits) || NormalizeDouble(OrderTakeProfit(), Digits) != NormalizeDouble(l_price_28 - Step * Point, Digits)) {
            li_8 = OrderModify(OrderTicket(), l_price_28, 0, l_price_28 - Step * Point, 0, Green);
            if (gi_140 == TRUE) Print(" SELL_STOP_201 ", OrderOpenPrice(), " -> ", l_price_28, " T/P = ", OrderTakeProfit(), " -> ", l_price_28 - Step * Point);
            if (li_8 == 0) {
               l_error_12 = GetLastError();
               if (gi_140 == TRUE) Print("  SELL_STOP_201 = ", l_error_12);
            }
            Sleep(1000 * gi_120);
            return;
         }
      }
   }
}

int deleteOrderNum(int a_magic_0) {
   int l_ord_delete_12;
   int l_error_16;
   int l_ord_total_4 = OrdersTotal();
   for (int l_pos_8 = 0; l_pos_8 < l_ord_total_4; l_pos_8++) {
      OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == a_magic_0) {
         if (gi_140 == TRUE) Print("   = ", a_magic_0, " Tiket = ", OrderTicket());
         l_ord_delete_12 = OrderDelete(OrderTicket());
         if (l_ord_delete_12 == 0) {
            l_error_16 = GetLastError();
            if (gi_140 == TRUE) Print("  = ", l_error_16);
         }
         Sleep(1000);
         return (1);
      }
   }
   return (0);
}

void Delete_BuyLimit_Old() {
   if (isOrderActive(101) == 0) {
      if (isMagNum(1, 102) == 1) deleteOrderNum(102);
      if (isMagNum(1, 103) == 1) deleteOrderNum(103);
      if (isMagNum(1, 104) == 1) deleteOrderNum(104);
      if (isMagNum(1, 105) == 1) deleteOrderNum(105);
      if (isMagNum(1, 106) == 1) deleteOrderNum(106);
      if (isMagNum(1, 107) == 1) deleteOrderNum(107);
      if (isMagNum(1, 108) == 1) deleteOrderNum(108);
      if (isMagNum(1, 109) == 1) deleteOrderNum(109);
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   int li_0 = getMaxLongNum();
   if (li_0 == 101) {
      if (isMagNum(1, 103) == 1) deleteOrderNum(103);
      if (isMagNum(1, 104) == 1) deleteOrderNum(104);
      if (isMagNum(1, 105) == 1) deleteOrderNum(105);
      if (isMagNum(1, 106) == 1) deleteOrderNum(106);
      if (isMagNum(1, 107) == 1) deleteOrderNum(107);
      if (isMagNum(1, 108) == 1) deleteOrderNum(108);
      if (isMagNum(1, 109) == 1) deleteOrderNum(109);
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 102) {
      if (isMagNum(1, 104) == 1) deleteOrderNum(104);
      if (isMagNum(1, 105) == 1) deleteOrderNum(105);
      if (isMagNum(1, 106) == 1) deleteOrderNum(106);
      if (isMagNum(1, 107) == 1) deleteOrderNum(107);
      if (isMagNum(1, 108) == 1) deleteOrderNum(108);
      if (isMagNum(1, 109) == 1) deleteOrderNum(109);
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 103) {
      if (isMagNum(1, 105) == 1) deleteOrderNum(105);
      if (isMagNum(1, 106) == 1) deleteOrderNum(106);
      if (isMagNum(1, 107) == 1) deleteOrderNum(107);
      if (isMagNum(1, 108) == 1) deleteOrderNum(108);
      if (isMagNum(1, 109) == 1) deleteOrderNum(109);
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 104) {
      if (isMagNum(1, 106) == 1) deleteOrderNum(106);
      if (isMagNum(1, 107) == 1) deleteOrderNum(107);
      if (isMagNum(1, 108) == 1) deleteOrderNum(108);
      if (isMagNum(1, 109) == 1) deleteOrderNum(109);
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 105) {
      if (isMagNum(1, 107) == 1) deleteOrderNum(107);
      if (isMagNum(1, 108) == 1) deleteOrderNum(108);
      if (isMagNum(1, 109) == 1) deleteOrderNum(109);
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 106) {
      if (isMagNum(1, 108) == 1) deleteOrderNum(108);
      if (isMagNum(1, 109) == 1) deleteOrderNum(109);
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 107) {
      if (isMagNum(1, 109) == 1) deleteOrderNum(109);
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 108) {
      if (isMagNum(1, 110) == 1) deleteOrderNum(110);
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 109) {
      if (isMagNum(1, 111) == 1) deleteOrderNum(111);
      if (isMagNum(1, 112) != 1) return;
      deleteOrderNum(112);
      return;
   }
   if (li_0 == 110) {
      if (isMagNum(1, 112) == 1) {
         deleteOrderNum(112);
         return;
      }
   }
}

void Delete_SellLimit_Old() {
   if (isOrderActive(201) == 0) {
      if (isMagNum(1, 202) == 1) deleteOrderNum(202);
      if (isMagNum(1, 203) == 1) deleteOrderNum(203);
      if (isMagNum(1, 204) == 1) deleteOrderNum(204);
      if (isMagNum(1, 205) == 1) deleteOrderNum(205);
      if (isMagNum(1, 206) == 1) deleteOrderNum(206);
      if (isMagNum(1, 207) == 1) deleteOrderNum(207);
      if (isMagNum(1, 208) == 1) deleteOrderNum(208);
      if (isMagNum(1, 209) == 1) deleteOrderNum(209);
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   int li_0 = getMaxShortNum();
   if (li_0 == 201) {
      if (isMagNum(1, 203) == 1) deleteOrderNum(203);
      if (isMagNum(1, 204) == 1) deleteOrderNum(204);
      if (isMagNum(1, 205) == 1) deleteOrderNum(205);
      if (isMagNum(1, 206) == 1) deleteOrderNum(206);
      if (isMagNum(1, 207) == 1) deleteOrderNum(207);
      if (isMagNum(1, 208) == 1) deleteOrderNum(208);
      if (isMagNum(1, 209) == 1) deleteOrderNum(209);
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 202) {
      if (isMagNum(1, 204) == 1) deleteOrderNum(204);
      if (isMagNum(1, 205) == 1) deleteOrderNum(205);
      if (isMagNum(1, 206) == 1) deleteOrderNum(206);
      if (isMagNum(1, 207) == 1) deleteOrderNum(207);
      if (isMagNum(1, 208) == 1) deleteOrderNum(208);
      if (isMagNum(1, 209) == 1) deleteOrderNum(209);
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 203) {
      if (isMagNum(1, 205) == 1) deleteOrderNum(205);
      if (isMagNum(1, 206) == 1) deleteOrderNum(206);
      if (isMagNum(1, 207) == 1) deleteOrderNum(207);
      if (isMagNum(1, 208) == 1) deleteOrderNum(208);
      if (isMagNum(1, 209) == 1) deleteOrderNum(209);
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 204) {
      if (isMagNum(1, 206) == 1) deleteOrderNum(206);
      if (isMagNum(1, 207) == 1) deleteOrderNum(207);
      if (isMagNum(1, 208) == 1) deleteOrderNum(208);
      if (isMagNum(1, 209) == 1) deleteOrderNum(209);
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 205) {
      if (isMagNum(1, 207) == 1) deleteOrderNum(207);
      if (isMagNum(1, 208) == 1) deleteOrderNum(208);
      if (isMagNum(1, 209) == 1) deleteOrderNum(209);
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 206) {
      if (isMagNum(1, 208) == 1) deleteOrderNum(208);
      if (isMagNum(1, 209) == 1) deleteOrderNum(209);
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 207) {
      if (isMagNum(1, 209) == 1) deleteOrderNum(209);
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 208) {
      if (isMagNum(1, 210) == 1) deleteOrderNum(210);
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 209) {
      if (isMagNum(1, 211) == 1) deleteOrderNum(211);
      if (isMagNum(1, 212) != 1) return;
      deleteOrderNum(212);
      return;
   }
   if (li_0 == 210) {
      if (isMagNum(1, 212) == 1) {
         deleteOrderNum(212);
         return;
      }
   }
}

int start() {
   int l_ticket_100;
   int li_132;
   int l_error_140;
   double ld_144;
   double l_price_168;
   double l_price_176;
   double ld_unused_0 = 0;
   if (Time[0] > StrToTime("2008.9.9")) {
      Alert("!  .", 
      "\n", "fx-auto-trader@mail.ru");
      Comment("!  .", 
      "\n", "fx-auto-trader@mail.ru");
      return (0);
   }
   if (100.0 * ((AccountBalance() - AccountEquity()) / AccountBalance()) - LossLimitLevel > 0.0) {
      deleteAll();
      Sleep(1000);
      deleteAll();
      Sleep(1000);
      deleteAll();
      Sleep(1000);
   }
   if (AccountFreeMargin() < 0.0) {
      Print("   . Free Margin = ", AccountFreeMargin());
      return (0);
   }
   if (AccountEquity() < 0.0) {
      Print("    = ", AccountEquity());
      return (0);
   }
   if (gi_116 > 15) {
      Print(" Risk  15 = ", gi_116);
      return (0);
   }
   if (gi_124 == FALSE && gi_128 == FALSE && gi_116 == 0) {
      Print("   StepSum  StepMultiply, Risk   = ", gi_116);
      return (0);
   }
   if (gi_124 == TRUE && gi_128 == TRUE) {
      Print(" StepSum  StepMultiply ");
      return (0);
   }
   if (gi_124 == TRUE && gi_112 < 1) {
      Print(" StepFactor  1 = ", gi_112);
      return (0);
   }
   if (gi_128 == TRUE && gi_112 < 2) {
      Print(" StepFactor  2 = ", gi_112);
      return (0);
   }
   if (StartLots == 0.0 && ReInvest == 0) {
      Print(" StartLots  ReInvest ");
      return (0);
   }
   if (StartLots > 0.0 && ReInvest > 0) {
      Print(" StartLots  ReInvest ");
      return (0);
   }
   if (gd_100 > 0.0)
      if (isMagNum(1, 101) == 0 && gd_100 == Ask - (Ask - Bid)) Create_Prima_Buy();
   if (gd_100 == 0.0)
      if (isMagNum(1, 101) == 0) Create_Prima_Buy();
   if (gd_100 > 0.0)
      if (isMagNum(1, 201) == 0 && gd_100 == Bid) Create_Prima_Sell();
   if (gd_100 == 0.0)
      if (isMagNum(1, 201) == 0) Create_Prima_Sell();
   Create_Modify_Prima_BuyStop();
   Create_Modify_Prima_SellStop();
   Delete_BuyLimit_Old();
   Delete_SellLimit_Old();
   double l_price_48 = 0;
   double l_price_40 = 0;
   int li_124 = getTopLevel(1);
   if (li_124 > 0) {
      li_132 = getMaxLongNum();
      ld_144 = getOrderPriceByNum(li_132);
      l_price_48 = getNextOrderPriceByNum(li_132, ld_144);
      l_price_168 = ld_144;
   }
   int li_128 = getTopLevel(2);
   if (li_128 > 0) {
      li_132 = getMaxShortNum();
      ld_144 = getOrderPriceByNum(li_132);
      l_price_40 = getNextOrderPriceByNum(li_132, ld_144);
      l_price_176 = ld_144;
   }
   if (l_price_48 > Bid) l_price_48 = Bid - Step * Point;
   if (l_price_40 < Ask) l_price_40 = Ask + Step * Point;
   if (li_124 == 1 && isMagNum(1, 102) == 0) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(2), l_price_48, 3, 0, l_price_168, " -   102", 102, 0, Green);
      if (gi_140 == TRUE) Print("     102 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   102 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 1 && isMagNum(1, 202) == 0) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(2), l_price_40, 3, 0, l_price_176, " -   202", 202, 0, Red);
      if (gi_140 == TRUE) Print("     202 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   202 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 2 && isMagNum(1, 103) == 0 && isOrderActive(102) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(3), l_price_48, 3, 0, l_price_168, " -   103", 103, 0, Green);
      if (gi_140 == TRUE) Print("     103 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   103 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 2 && isMagNum(1, 203) == 0 && isOrderActive(202) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(3), l_price_40, 3, 0, l_price_176, " -   203", 203, 0, Red);
      if (gi_140 == TRUE) Print("     203 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   203 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 3 && isMagNum(1, 104) == 0 && isOrderActive(103) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(4), l_price_48, 3, 0, l_price_168, " -   104", 104, 0, Green);
      if (gi_140 == TRUE) Print("     104 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   104 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 3 && isMagNum(1, 204) == 0 && isOrderActive(203) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(4), l_price_40, 3, 0, l_price_176, " -   204", 204, 0, Red);
      if (gi_140 == TRUE) Print("     204 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   204 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 4 && isMagNum(1, 105) == 0 && isOrderActive(104) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(5), l_price_48, 3, 0, l_price_168, " -   105", 105, 0, Green);
      if (gi_140 == TRUE) Print("     105 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   105 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 4 && isMagNum(1, 205) == 0 && isOrderActive(204) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(5), l_price_40, 3, 0, l_price_176, " -   205", 205, 0, Red);
      if (gi_140 == TRUE) Print("     205 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   205 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 5 && isMagNum(1, 106) == 0 && isOrderActive(105) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(6), l_price_48, 3, 0, l_price_168, " -   106", 106, 0, Green);
      if (gi_140 == TRUE) Print("     106 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   106 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 5 && isMagNum(1, 206) == 0 && isOrderActive(205) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(6), l_price_40, 3, 0, l_price_176, " -   206", 206, 0, Red);
      if (gi_140 == TRUE) Print("     206 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   206 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 6 && isMagNum(1, 107) == 0 && isOrderActive(106) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(7), l_price_48, 3, 0, l_price_168, " -   107", 107, 0, Green);
      if (gi_140 == TRUE) Print("     107 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   107 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 6 && isMagNum(1, 207) == 0 && isOrderActive(206) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(7), l_price_40, 3, 0, l_price_176, " -   207", 207, 0, Red);
      if (gi_140 == TRUE) Print("     207 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   207 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 7 && isMagNum(1, 108) == 0 && isOrderActive(107) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(8), l_price_48, 3, 0, l_price_168, " -   108", 108, 0, Green);
      if (gi_140 == TRUE) Print("     108 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   108 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 7 && isMagNum(1, 208) == 0 && isOrderActive(207) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(8), l_price_40, 3, 0, l_price_176, " -   208", 208, 0, Red);
      if (gi_140 == TRUE) Print("     208 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   208 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 8 && isMagNum(1, 109) == 0 && isOrderActive(108) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(9), l_price_48, 3, 0, l_price_168, " -   109", 109, 0, Green);
      if (gi_140 == TRUE) Print("     109 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   109 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 8 && isMagNum(1, 209) == 0 && isOrderActive(208) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(9), l_price_40, 3, 0, l_price_176, " -   209", 209, 0, Red);
      if (gi_140 == TRUE) Print("     209 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   209 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 9 && isMagNum(1, 110) == 0 && isOrderActive(109) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(10), l_price_48, 3, 0, l_price_168, " -   110", 110, 0, Green);
      if (gi_140 == TRUE) Print("     110 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   110 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 9 && isMagNum(1, 210) == 0 && isOrderActive(209) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(10), l_price_40, 3, 0, l_price_176, " -   210", 210, 0, Red);
      if (gi_140 == TRUE) Print("     210 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   210 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 10 && isMagNum(1, 111) == 0 && isOrderActive(110) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(11), l_price_48, 3, 0, l_price_168, " -   111", 111, 0, Green);
      if (gi_140 == TRUE) Print("     111 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   111 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 10 && isMagNum(1, 211) == 0 && isOrderActive(210) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(11), l_price_40, 3, 0, l_price_176, " -   211", 211, 0, Red);
      if (gi_140 == TRUE) Print("     211 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   211 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_124 == 11 && isMagNum(1, 112) == 0 && isOrderActive(111) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_BUYLIMIT, getLotByLevel(12), l_price_48, 3, 0, l_price_168, " -   112", 112, 0, Green);
      if (gi_140 == TRUE) Print("     112 ", Symbol(), " Ask = ", l_price_48, " T/P = ", l_price_168, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   112 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   if (li_128 == 11 && isMagNum(1, 212) == 0 && isOrderActive(211) == 1) {
      l_ticket_100 = OrderSend(Symbol(), OP_SELLLIMIT, getLotByLevel(12), l_price_40, 3, 0, l_price_176, " -   212", 212, 0, Red);
      if (gi_140 == TRUE) Print("     212 ", Symbol(), " Bid = ", l_price_40, " T/P = ", l_price_176, " Ticket = ", l_ticket_100);
      if (l_ticket_100 == -1) {
         l_error_140 = GetLastError();
         if (gi_140 == TRUE) Print("   212 = ", l_error_140);
      }
      Sleep(1000 * gi_120);
   }
   double ld_64 = getOrderPriceByNum(101) + Step * Point;
   double ld_72 = getOrderPriceByNum(201) - Step * Point;
   if (isOrderActive(112) == 1) ld_64 = getOrderPriceByNum(111);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 1) ld_64 = getOrderPriceByNum(110);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 1) ld_64 = getOrderPriceByNum(109);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 0 && isOrderActive(109) == 1) ld_64 = getOrderPriceByNum(108);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 0 && isOrderActive(109) == 0 && isOrderActive(108) == 1) ld_64 = getOrderPriceByNum(107);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 0 && isOrderActive(109) == 0 && isOrderActive(108) == 0 && isOrderActive(107) == 1) ld_64 = getOrderPriceByNum(106);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 0 && isOrderActive(109) == 0 && isOrderActive(108) == 0 && isOrderActive(107) == 0 &&
      isOrderActive(106) == 1) ld_64 = getOrderPriceByNum(105);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 0 && isOrderActive(109) == 0 && isOrderActive(108) == 0 && isOrderActive(107) == 0 &&
      isOrderActive(106) == 0 && isOrderActive(105) == 1) ld_64 = getOrderPriceByNum(104);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 0 && isOrderActive(109) == 0 && isOrderActive(108) == 0 && isOrderActive(107) == 0 &&
      isOrderActive(106) == 0 && isOrderActive(105) == 0 && isOrderActive(104) == 1) ld_64 = getOrderPriceByNum(103);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 0 && isOrderActive(109) == 0 && isOrderActive(108) == 0 && isOrderActive(107) == 0 &&
      isOrderActive(106) == 0 && isOrderActive(105) == 0 && isOrderActive(104) == 0 && isOrderActive(103) == 1) ld_64 = getOrderPriceByNum(102);
   if (isOrderActive(112) == 0 && isOrderActive(111) == 0 && isOrderActive(110) == 0 && isOrderActive(109) == 0 && isOrderActive(108) == 0 && isOrderActive(107) == 0 &&
      isOrderActive(106) == 0 && isOrderActive(105) == 0 && isOrderActive(104) == 0 && isOrderActive(103) == 0 && isOrderActive(102) == 1)
      if (isOrderActive(101) == 1) ld_64 = getOrderPriceByNum(101);
   if (isOrderActive(212) == 1) ld_72 = getOrderPriceByNum(211);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 1) ld_72 = getOrderPriceByNum(210);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 1) ld_72 = getOrderPriceByNum(209);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 0 && isOrderActive(209) == 1) ld_72 = getOrderPriceByNum(208);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 0 && isOrderActive(209) == 0 && isOrderActive(208) == 1) ld_72 = getOrderPriceByNum(207);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 0 && isOrderActive(209) == 0 && isOrderActive(208) == 0 && isOrderActive(207) == 1) ld_72 = getOrderPriceByNum(206);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 0 && isOrderActive(209) == 0 && isOrderActive(208) == 0 && isOrderActive(207) == 0 &&
      isOrderActive(206) == 1) ld_72 = getOrderPriceByNum(205);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 0 && isOrderActive(209) == 0 && isOrderActive(208) == 0 && isOrderActive(207) == 0 &&
      isOrderActive(206) == 0 && isOrderActive(205) == 1) ld_72 = getOrderPriceByNum(204);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 0 && isOrderActive(209) == 0 && isOrderActive(208) == 0 && isOrderActive(207) == 0 &&
      isOrderActive(206) == 0 && isOrderActive(205) == 0 && isOrderActive(204) == 1) ld_72 = getOrderPriceByNum(203);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 0 && isOrderActive(209) == 0 && isOrderActive(208) == 0 && isOrderActive(207) == 0 &&
      isOrderActive(206) == 0 && isOrderActive(205) == 0 && isOrderActive(204) == 0 && isOrderActive(203) == 1) ld_72 = getOrderPriceByNum(202);
   if (isOrderActive(212) == 0 && isOrderActive(211) == 0 && isOrderActive(210) == 0 && isOrderActive(209) == 0 && isOrderActive(208) == 0 && isOrderActive(207) == 0 &&
      isOrderActive(206) == 0 && isOrderActive(205) == 0 && isOrderActive(204) == 0 && isOrderActive(203) == 0 && isOrderActive(202) == 1)
      if (isOrderActive(201) == 1) ld_72 = getOrderPriceByNum(201);
   setNewTakeProfitBuy(ld_64);
   setNewTakeProfitSel(ld_72);
   li_132 = getMaxLongNum();
   ld_144 = getOrderPriceByNum(li_132);
   double ld_152 = getNextOrderPriceByNum(li_132, ld_144);
   int li_136 = getNextOrderNum(li_132);
   if (isMagNum(1, li_136) == 1 && ld_152 < Bid - (Ask - Bid) - 3.0 * Point) modOrder(li_136, ld_152, ld_144);
   li_132 = getMaxShortNum();
   ld_144 = getOrderPriceByNum(li_132);
   ld_152 = getNextOrderPriceByNum(li_132, ld_144);
   li_136 = getNextOrderNum(li_132);
   if (isMagNum(1, li_136) == 1 && ld_152 > Ask + (Ask - Bid) + 3.0 * Point) modOrder(li_136, ld_152, ld_144);
   return (0);
}
